/**
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/NG-ZORRO/ng-zorro-antd/blob/master/LICENSE
 */
import { ElementRef, NgZone, OnDestroy } from '@angular/core';
import { ZoomBehavior } from 'd3-zoom';
import { NzSafeAny } from 'ng-zorro-antd/core/types';
import { Minimap } from './core/minimap';
import { NzZoomTransform } from './interface';
import * as i0 from "@angular/core";
export declare class NzGraphMinimapComponent implements OnDestroy {
    private elementRef;
    private ngZone;
    minimap?: Minimap;
    constructor(elementRef: ElementRef<HTMLElement>, ngZone: NgZone);
    ngOnDestroy(): void;
    init(containerEle: ElementRef, zoomBehavior: ZoomBehavior<NzSafeAny, NzSafeAny>): void;
    zoom(transform: NzZoomTransform): void;
    update(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NzGraphMinimapComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NzGraphMinimapComponent, "nz-graph-minimap", never, {}, {}, never, never>;
}
